# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Tue Jun  7 09:18:11 2011

import wx

import ConfigElements
from core.application import Application
from core.config import FontOption
from gui.guiconfig import TextPrintConfig

# begin wxGlade: dependencies
# end wxGlade

# begin wxGlade: extracode

# end wxGlade

class TextPrintPanel(wx.Panel):
	def __init__(self, *args, **kwds):
		# begin wxGlade: TextPrintPanel.__init__
		kwds["style"] = wx.TAB_TRAVERSAL
		wx.Panel.__init__(self, *args, **kwds)
		self.sharedTextLabel = wx.StaticText(self, -1, _("This options for text printing only"), style=wx.ALIGN_CENTRE)
		self.fontLabel = wx.StaticText(self, -1, _("Font"))
		self.fontPicker = wx.FontPickerCtrl(self, -1)
		self.pageOptionsBtn = wx.Button(self, -1, _("Page Options..."))

		self.__set_properties()
		self.__do_layout()

		self.Bind(wx.EVT_BUTTON, self.onPageOptions, self.pageOptionsBtn)
		# end wxGlade
		
		self.config = TextPrintConfig (Application.config)
		self.LoadState()


	def __set_properties(self):
		# begin wxGlade: TextPrintPanel.__set_properties
		self.SetSize((400, 300))
		self.fontLabel.SetMinSize((200, -1))
		# end wxGlade

	def __do_layout(self):
		# begin wxGlade: TextPrintPanel.__do_layout
		mainSizer = wx.FlexGridSizer(3, 1, 0, 0)
		fontSizer = wx.FlexGridSizer(1, 2, 0, 0)
		mainSizer.Add(self.sharedTextLabel, 0, wx.ALL, 2)
		fontSizer.Add(self.fontLabel, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 2)
		fontSizer.Add(self.fontPicker, 1, wx.EXPAND, 0)
		fontSizer.AddGrowableCol(1)
		mainSizer.Add(fontSizer, 1, wx.EXPAND, 0)
		mainSizer.Add(self.pageOptionsBtn, 0, wx.ALL, 2)
		self.SetSizer(mainSizer)
		mainSizer.AddGrowableCol(0)
		# end wxGlade

	def onPageOptions(self, event): # wxGlade: TextPrintPanel.<event_handler>
		pd = wx.PrintData ()
		psdd = wx.PageSetupDialogData (pd)

		psdd.SetMarginTopLeft (wx.Point (self.config.marginLeft.value, self.config.marginTop.value) )
		psdd.SetMarginBottomRight (wx.Point (self.config.marginRight.value, self.config.marginBottom.value) )
		psdd.SetPaperId (self.config.paperId.value)

		dlg = wx.PageSetupDialog (self, psdd)

		if dlg.ShowModal() == wx.ID_OK:
			psdd_new = dlg.GetPageSetupData()

			marginLeftTop = psdd_new.GetMarginTopLeft()
			marginRightBottom = psdd_new.GetMarginBottomRight()

			self.config.marginLeft.value = marginLeftTop[0]
			self.config.marginTop.value = marginLeftTop[1]

			self.config.marginRight.value = marginRightBottom[0]
			self.config.marginBottom.value = marginRightBottom[1]

			self.config.paperId.value = psdd_new.GetPaperId()


	def LoadState(self):
		# Обычный шрифт
		fontOption = FontOption (self.config.fontFaceNameOption, 
				self.config.fontSizeOption, 
				self.config.fontIsBold, 
				self.config.fontIsItalic)

		self.font = ConfigElements.FontElement (fontOption, self.fontPicker)


	def Save (self):
		self.font.save()

# end of class TextPrintPanel


